=== include/CMakeLists.txt ===
if(INSTALL_SDK)
  file(GLOB public_headers LIST_DIRECTORIES false "cnoid/*")
  foreach(file ${public_headers})
    install(FILES ${file} DESTINATION ${CNOID_HEADER_SUBDIR}/cnoid)
  endforeach()
  file(GLOB public_headers LIST_DIRECTORIES false "cnoid/stdx/*")
  foreach(file ${public_headers})
    install(FILES ${file} DESTINATION ${CNOID_HEADER_SUBDIR}/cnoid/stdx)
  endforeach()
endif()
