=== misc/CMakeLists.txt ===
add_subdirectory(script)
add_subdirectory(pkgconfig)
