=== misc/script/CMakeLists.txt ===
configure_file(extract-messages-initial.sh.in extract-messages-initial.sh @ONLY)
configure_file(extract-messages.sh.in extract-messages.sh @ONLY)
configure_file(make_header_public.rb.in make_header_public.rb @ONLY)
configure_file(make_binary_package.sh.template make_binary_package.sh @ONLY)
configure_file(make_src_archive.sh.in make_src_archive.sh @ONLY)

if(WIN32)
  configure_file(install_win32_deps.rb.template install_win32_deps.rb)
endif()

if(UNIX)
  option(INSTALL_SYNC_LOGFILE_COMMAND "Installing the choreonoid-sync-logfile command" OFF)
  mark_as_advanced(INSTALL_SYNC_LOGFILE_COMMAND)
  if(INSTALL_SYNC_LOGFILE_COMMAND)
    configure_file(sync-logfile.sh ${PROJECT_BINARY_DIR}/bin/choreonoid-sync-logfile COPYONLY)
  endif()
endif()
