=== debian/changelog ===
choreonoid (2.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Shin'ichiro Nakaoka <s.nakaoka@gmail.com>  Wed, 04 Sep 2025 12:00:00 +0900
