=== debian/control ===
Source: choreonoid
Section: science
Priority: optional
Maintainer: Shin'ichiro Nakaoka <s.nakaoka@gmail.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               cmake-curses-gui,
               libeigen3-dev,
               uuid-dev,
               libxfixes-dev,
               libyaml-dev,
               libfmt-dev,
               gettext,
               zlib1g-dev,
               libzip-dev,
               libjpeg-dev,
               libpng-dev,
               libfreetype-dev,
               qt6-base-dev,
               libqt6opengl6-dev,
               qt6-svg-dev | libqt6svg6-dev,
               qt6-translations-l10n | qt6-l10n-tools,
               libglu1-mesa-dev,
               python3-dev,
               python3-numpy,
               libassimp-dev,
               libode-dev,
               libfcl-dev,
               libpulse-dev,
               libsndfile1-dev,
               libgstreamer1.0-dev,
               libgstreamer-plugins-base1.0-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev
Standards-Version: 4.6.2
Homepage: https://choreonoid.org/
Vcs-Browser: https://github.com/choreonoid/choreonoid
Vcs-Git: https://github.com/choreonoid/choreonoid.git

Package: choreonoid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	 cmake,
         cmake-curses-gui,
         libeigen3-dev,
         libfmt-dev,
         gettext,
	 qt6-base-dev,
         libqt6opengl6-dev,
         qt6-svg-dev | libqt6svg6-dev,
         qt6-translations-l10n | qt6-l10n-tools,
	 qt6-qpa-plugins,
         libglu1-mesa-dev,
         python3,
         python3-numpy,
         python3-dev
Recommends: python3-yaml
Description: Integrated robotics GUI environment
 Choreonoid is an open-source, lightweight, and extensible integrated
 graphical framework for robot development. It provides model visualization,
 dynamics simulation, choreographing, and various robot development tools.
