=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Get the architecture for build directory naming
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# Disable Debian's automatic LTO flags (both -flto=auto and -ffat-lto-objects)
# Choreonoid manages LTO internally via ENABLE_LTO=ON
export DEB_BUILD_MAINT_OPTIONS = optimize=-lto

%:
	dh $@ --buildsystem=cmake --builddirectory=obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	dh_auto_configure --builddirectory=obj-$(DEB_HOST_GNU_TYPE) -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DENABLE_INSTALL_RPATH=OFF \
		-DENABLE_LTO=ON \
		-DBUILD_CHOREONOID_INFO_COMMAND=ON \
		-DBUILD_FCL_PLUGIN=ON \
		-DBUILD_ODE_PLUGIN=ON \
		-DBUILD_LIVOX_MID360_PLUGIN=ON \
		-DBUILD_GL_CAMERA_EFFECT_PLUGIN=ON \
		-DBUILD_SCENE_EFFECTS_PLUGIN=ON \
		-DBUILD_POSE_SEQ_PLUGIN=ON \
		-DBUILD_BALANCER_PLUGIN=ON \
		-DBUILD_MULTICOPTER_PLUGIN=ON \
		-DBUILD_FFMPEG_PLUGIN=ON \
		-DBUILD_MEDIA_PLUGIN=ON \
		-DBUILD_MOCAP_PLUGIN=ON \
		-DBUILD_HRP4C_HANDLER=ON \
		-DBUILD_SUBMERSIBLE_SAMPLE=ON
